diff --git a/src/test_sfw_srv.c b/src/test_sfw_srv.c
index 359b48f..2481168 100644
--- a/src/test_sfw_srv.c
+++ b/src/test_sfw_srv.c
@@ -120,7 +120,7 @@ void finalize_sfw(int ctlsockfd) {
  *			5 - Unable to resolve client address
  */
 
-int test_sfw_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_sfw_srv(int ctlsockfd, tcp_stat_agent* agent, TestOptions* options,
                  int conn_options) {
   char buff[BUFFSIZE + 1];
   I2Addr sfwsrv_addr = NULL;
@@ -130,9 +130,15 @@ int test_sfw_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
   fd_set fds;
   struct timeval sel_tv;
   int msgLen, msgType;
+
+#if USE_WEB100
   web100_var* var;
   web100_connection* cn;
   web100_group* group;
+#elif USE_TCPE
+  struct tcpe_val value;
+  int cn;
+#endif
   int maxRTT, maxRTO;
   char hostname[256];
   int rc;
@@ -169,26 +175,39 @@ int test_sfw_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
     sfwsockport = I2AddrPort(sfwsrv_addr);
     log_println(1, "  -- port: %d", sfwsockport);
 
-    cn = web100_connection_from_socket(agent, ctlsockfd);
+    cn = tcp_stat_connection_from_socket(agent, ctlsockfd);
     if (cn) {
       // Get remote end's address
+      memset(hostname, 0, sizeof(hostname));
+
+#if USE_WEB100
       web100_agent_find_var_and_group(agent, "RemAddress", &group, &var);
       web100_raw_read(var, cn, buff);
-      memset(hostname, 0, 256);
       // strncpy(hostname, web100_value_to_text(web100_get_var_type(var), buff),
       //         255);
       strlcpy(hostname, web100_value_to_text(web100_get_var_type(var), buff),
               sizeof(hostname));
+#elif USE_TCPE
+      web10g_get_remote_addr(agent, cn, hostname, sizeof(hostname));
+#endif
 
       // Determine test time in seconds.
       // test-time = max(round trip time, timeout) > 3 ? 3 : 1
 
+#if USE_WEB100
       web100_agent_find_var_and_group(agent, "MaxRTT", &group, &var);
       web100_raw_read(var, cn, buff);
       maxRTT = atoi(web100_value_to_text(web100_get_var_type(var), buff));
       web100_agent_find_var_and_group(agent, "MaxRTO", &group, &var);
       web100_raw_read(var, cn, buff);
       maxRTO = atoi(web100_value_to_text(web100_get_var_type(var), buff));
+#elif USE_TCPE
+      web10g_get_val(agent, cn, "MaxRTT", &value);
+      maxRTT = value.uv32;
+      web10g_get_val(agent, cn, "MaxRTO", &value);
+      maxRTO = value.uv32;
+#endif
+
       if (maxRTT > maxRTO)
         maxRTO = maxRTT;
       if ((((double) maxRTO) / 1000.0) > 3.0)
diff --git a/src/testoptions.c b/src/testoptions.c
index d16c383..2b40e7b 100644
--- a/src/testoptions.c
+++ b/src/testoptions.c
@@ -24,7 +24,7 @@
 // Worker thread characteristics used to record snaplog and Cwnd peaks
 typedef struct workerArgs {
   SnapArgs* snapArgs;  // snapArgs struct pointer
-  web100_agent* agent;  // web_100 agent pointer
+  tcp_stat_agent* agent;  // tcp_stat agent pointer
   CwndPeaks* peaks;  // data indicating Cwnd values
   int writeSnap;  // enable writing snaplog
 } WorkerArgs;
@@ -44,17 +44,25 @@ static int decreasing = 0;
  * @param peaks Structure containing CWND peaks information
  * @param snap Web100 snapshot structure
  */
-
-void findCwndPeaks(web100_agent* agent, CwndPeaks* peaks,
-                   web100_snapshot* snap) {
+void findCwndPeaks(tcp_stat_agent* agent, CwndPeaks* peaks,
+                   tcp_stat_snap* snap) {
+  int CurCwnd;
+#if USE_WEB100
   web100_group* group;
   web100_var* var;
-  int CurCwnd;
   char tmpstr[256];
+#elif USE_TCPE
+  struct tcpe_val value;
+#endif
 
+#if USE_WEB100
   web100_agent_find_var_and_group(agent, "CurCwnd", &group, &var);
   web100_snap_read(var, snap, tmpstr);
   CurCwnd = atoi(web100_value_to_text(web100_get_var_type(var), tmpstr));
+#elif USE_TCPE
+  web10g_find_val(snap, "CurCwnd", &value);
+  CurCwnd = value.uv32;
+#endif
 
   if (slowStart) {
     if (CurCwnd < prevCWNDval) {
@@ -108,9 +116,11 @@ void catch_s2c_alrm(int signo) {
 
 void*
 snapWorker(void* arg) {
+  /* WARNING void* arg (workerArgs) is on the stack of the function below and
+   * doesn't exist forever. */
   WorkerArgs *workerArgs = (WorkerArgs*) arg;
   SnapArgs *snapArgs = workerArgs->snapArgs;
-  web100_agent* agent = workerArgs->agent;
+  tcp_stat_agent* agent = workerArgs->agent;
   CwndPeaks* peaks = workerArgs->peaks;
   int writeSnap = workerArgs->writeSnap;
 
@@ -136,6 +146,7 @@ snapWorker(void* arg) {
       pthread_mutex_unlock(&mainmutex);
       break;
     }
+#if USE_WEB100
     web100_snap(snapArgs->snap);
     if (peaks) {
       findCwndPeaks(agent, peaks, snapArgs->snap);
@@ -143,6 +154,15 @@ snapWorker(void* arg) {
     if (writeSnap) {
       web100_log_write(snapArgs->log, snapArgs->snap);
     }
+#elif USE_TCPE
+    tcpe_read_vars(snapArgs->snap, snapArgs->conn, agent);
+    if (peaks) {
+      findCwndPeaks(agent, peaks, snapArgs->snap);
+    }
+    if (writeSnap) {
+      // TODO: logging
+    }
+#endif
     pthread_mutex_unlock(&mainmutex);
     mysleep(delay);
   }
@@ -249,20 +269,20 @@ int initialize_tests(int ctlsockfd, TestOptions* options, char * buff,
 
 /** Method to start snap worker thread that collects snap logs
  * @param snaparg object
- * @param web100_agent Agent
+ * @param tcp_stat_agent Agent
  * @param snaplogenabled Is snap logging enabled?
- * @param workerlooparg integer used to syncronize writing/reading from snaplog/web100 snapshot
+ * @param workerlooparg integer used to syncronize writing/reading from snaplog/tcp_stat snapshot
  * @param wrkrthreadidarg Thread Id of workera
  * @param metafilevariablename Which variable of the meta file gets assigned the snaplog name (unused now)
  * @param metafilename	value of metafile name
- * @param web100_connection connection pointer
- * @param web100_group group web100_group pointer
+ * @param tcp_stat_connection connection pointer
+ * @param tcp_stat_group group web100_group pointer
  */
-void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
+void start_snap_worker(SnapArgs *snaparg, tcp_stat_agent* agentarg,
                        CwndPeaks* peaks, char snaplogenabled,
                        pthread_t *wrkrthreadidarg, char *metafilevariablename,
-                       char *metafilename, web100_connection* conn,
-                       web100_group* group) {
+                       char *metafilename, tcp_stat_connection conn,
+                       tcp_stat_group* group) {
   FILE *fplocal;
 
   WorkerArgs workerArgs;
@@ -271,8 +291,13 @@ void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
   workerArgs.peaks = peaks;
   workerArgs.writeSnap = snaplogenabled;
 
+#if USE_WEB100
   group = web100_group_find(agentarg, "read");
   snaparg->snap = web100_snapshot_alloc(group, conn);
+#elif USE_TCPE
+  snaparg->conn = conn;
+  tcpe_data_new(&snaparg->snap);
+#endif
 
   if (snaplogenabled) {
     // memcpy(metafilevariablename, metafilename, strlen(metafilename));
@@ -280,7 +305,10 @@ void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
     // just the file name, but full filename is needed to open the log file
 
     fplocal = fopen(get_logfile(), "a");
+
+#if USE_WEB100
     snaparg->log = web100_log_open_write(metafilename, conn, group);
+#endif
     if (fplocal == NULL) {
       log_println(
           0,
@@ -302,10 +330,15 @@ void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
   pthread_mutex_lock(&mainmutex);
   workerLoop= 1;
   // obtain web100 snap into "snaparg.snap"
+#if USE_WEB100
   web100_snap(snaparg->snap);
   if (snaplogenabled) {
     web100_log_write(snaparg->log, snaparg->snap);
   }
+#elif USE_TCPE
+  tcpe_read_vars(snaparg->snap, conn, agentarg);
+  // TODO: logging
+#endif
   pthread_cond_wait(&maincond, &mainmutex);
   pthread_mutex_unlock(&mainmutex);
 }
@@ -325,11 +358,15 @@ void stop_snap_worker(pthread_t *workerThreadId, char snaplogenabled,
     pthread_join(*workerThreadId, NULL);
   }
   // close writing snaplog, if snaplog recording is enabled
+#if USE_WEB100
   if (snaplogenabled) {
     web100_log_close_write(snapArgs_ptr->log);
   }
 
   web100_snapshot_free(snapArgs_ptr->snap);
+#elif USE_TCPE
+  tcpe_data_free(&snapArgs_ptr->snap);
+#endif
 }
 
 /**
@@ -411,22 +448,28 @@ void stop_packet_trace(int *monpipe_arr) {
 
 /**
  * Set Cwnd limit
- * @param connarg web100_connection pointer
- * @param group_arg web100 group pointer
- * @param agentarg web100 agent pointer
+ * @param connarg tcp_stat_connection pointer
+ * @param group_arg tcp_stat group pointer
+ * @param agentarg tcp_stat agent pointer
  * */
-void setCwndlimit(web100_connection* connarg, web100_group* grouparg,
-                  web100_agent* agentarg, Options* optionsarg) {
+void setCwndlimit(tcp_stat_connection connarg, tcp_stat_group* grouparg,
+                  tcp_stat_agent* agentarg, Options* optionsarg) {
+#if USE_WEB100
   web100_var *LimRwin, *yar;
+#elif USE_TCPE
+  struct tcpe_val yar;
+#endif
+
   u_int32_t limrwin_val;
-  char yuff[32];
 
   if (optionsarg->limit > 0) {
     log_print(1, "Setting Cwnd limit - ");
 
+#if USE_WEB100
     if (connarg != NULL) {
       log_println(1,
                   "Got web100 connection pointer for recvsfd socket\n");
+      char yuff[32];
       web100_agent_find_var_and_group(agentarg, "CurMSS", &grouparg,
                                       &yar);
       web100_raw_read(yar, connarg, yuff);
@@ -442,6 +485,17 @@ void setCwndlimit(web100_connection* connarg, web100_group* grouparg,
       log_print(1, "now write %d to limit the Receive window",
                 limrwin_val);
       web100_raw_write(LimRwin, connarg, &limrwin_val);
+#elif USE_TCPE
+    if (connarg != -1) {
+      log_println(1,
+                  "Got web10g connection for recvsfd socket\n");
+      web10g_get_val(agentarg, connarg, "CurMSS", &yar);
+      log_println(1, "MSS = %s, multiplication factor = %d",
+                  yar.uv32, optionsarg->limit);
+      limrwin_val = optionsarg->limit * yar.uv32;
+      log_print(1, "now write %d to limit the Receive window", limrwin_val);
+      tcpe_write_var("LimRwin", limrwin_val, connarg, agentarg);
+#endif
       log_println(1, "  ---  Done");
     }
   }
diff --git a/src/testoptions.h b/src/testoptions.h
index c2eaa93..c5eaee6 100644
--- a/src/testoptions.h
+++ b/src/testoptions.h
@@ -17,7 +17,6 @@
 #define RETRY_EXCEEDED_WAITING_DATA -102
 #define SOCKET_STATUS_FAILED -1
 
-
 typedef struct testoptions {
   int multiple;  // multiples tests enabled
   int mainport;  // main port used for test
@@ -47,8 +46,9 @@ typedef struct testoptions {
 
 // Snap log characteristics
 typedef struct snapArgs {
-  web100_snapshot* snap;  // web_100 snapshot indicator
-  web100_log* log;  // web_100 log
+  tcp_stat_connection conn;
+  tcp_stat_snap* snap;
+  tcp_stat_log* log;
   int delay;  // periodicity, in ms, of collecting snap
 } SnapArgs;
 
@@ -59,26 +59,26 @@ int initialize_tests(int ctlsockfd, TestOptions* testOptions,
 
 void catch_s2c_alrm(int signo);
 
-int test_sfw_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_sfw_srv(int ctlsockfd, tcp_stat_agent* agent, TestOptions* options,
                  int conn_options);
-int test_meta_srv(int ctlsockfd, web100_agent* agent, TestOptions* options,
+int test_meta_srv(int ctlsockfd, tcp_stat_agent* agent, TestOptions* options,
                   int conn_options);
 
 int getCurrentTest();
 void setCurrentTest(int testId);
 
-// void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
-void start_snap_worker(SnapArgs *snaparg, web100_agent *agentarg,
+// void start_snap_worker(SnapArgs *snaparg, tcp_stat_agent *agentarg,
+void start_snap_worker(SnapArgs *snaparg, tcp_stat_agent *agentarg,
                        CwndPeaks* peaks, char snaplogenabled,
                        pthread_t *wrkrthreadidarg, char *metafilevariablename,
-                       char *metafilename, web100_connection* conn,
-                       web100_group* group);
+                       char *metafilename, tcp_stat_connection conn,
+                       tcp_stat_group* group);
 
 void stop_snap_worker(pthread_t *workerThreadId, char snaplogenabled,
                       SnapArgs* snapArgs_ptr);
 
-void setCwndlimit(web100_connection* connarg, web100_group* grouparg,
-                  web100_agent* agentarg, Options* optionsarg);
+void setCwndlimit(tcp_stat_connection connarg, tcp_stat_group* grouparg,
+                  tcp_stat_agent* agentarg, Options* optionsarg);
 
 int is_buffer_clogged(int nextseqtosend, int lastunackedseq);
 void stop_packet_trace(int *monpipe_arr);
diff --git a/src/tests_srv.h b/src/tests_srv.h
index baaed65..4d86947 100644
--- a/src/tests_srv.h
+++ b/src/tests_srv.h
@@ -11,19 +11,19 @@
 
 #include "testoptions.h"
 
-int test_c2s(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_c2s(int ctlsockfd, tcp_stat_agent* agent, TestOptions* testOptions,
              int conn_options, double* c2sspd, int set_buff, int window,
              int autotune, char* device, Options* options, int record_reverse,
              int count_vars, char spds[4][256], int* spd_index);
 
 // S2C test
-int test_s2c(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_s2c(int ctlsockfd, tcp_stat_agent* agent, TestOptions* testOptions,
              int conn_options, double* s2cspd, int set_buff, int window,
              int autotune, char* device, Options* options, char spds[4][256],
              int* spd_index, int count_vars, CwndPeaks* peaks);
 
 // the middlebox test
-int test_mid(int ctlsockfd, web100_agent* agent, TestOptions* testOptions,
+int test_mid(int ctlsockfd, tcp_stat_agent* agent, TestOptions* testOptions,
              int conn_options, double* s2c2spd);
 
 #endif  // SRC_TESTS_SRV_H_
diff --git a/src/web100-admin.c b/src/web100-admin.c
index 06bf6e7..319ec22 100644
--- a/src/web100-admin.c
+++ b/src/web100-admin.c
@@ -7,16 +7,18 @@
  * rcarlson@internet2.edu
  */
 
+#include "web100-admin.h"
+
 #include <math.h>
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <unistd.h>
 
-#include "web100srv.h"
+#include "heuristics.h"
 #include "logging.h"
-#include "web100-admin.h"
-#include "utils.h"
 #include "strlutils.h"
+#include "utils.h"
+#include "web100srv.h"
 
 /* Initialize the Administrator view.  Process the data in the existing log file to
  * catch up on what's happened before.
diff --git a/src/web100-pcap.c b/src/web100-pcap.c
index 889da44..783df4d 100644
--- a/src/web100-pcap.c
+++ b/src/web100-pcap.c
@@ -90,6 +90,15 @@ void get_iflist(void) {
     pcap_freealldevs(alldevs);
 }
 
+/**
+ * Force the pcap_loop to return. Safe to call from signal handler.
+ */
+void force_breakloop() {
+  if (pd != NULL) {
+    pcap_breakloop(pd);
+  }
+}
+
 /** Check signal flags and process them accordingly.
  *  If signal indicates request to terminate data collection for the speed bins,
  * 	make packet-pair based speed bins available to the parent process.
@@ -97,7 +106,7 @@ void get_iflist(void) {
  * @return 1 if data was successfully written
  * 		   0 if no relevant signals were actually received
  */
-int check_signal_flags() {
+static int check_signal_flags() {
   if ((sig1 == 1) || (sig2 == 1)) {
     log_println(
         5,
@@ -135,9 +144,6 @@ int check_signal_flags() {
       usleep(30000); /* wait here 30 msec, for parent to read this data */
       print_bins(&rev, mon_pipe1);
       usleep(30000); /* wait here 30 msec, for parent to read this data */
-      if (pd != NULL) {
-        pcap_breakloop(pd);
-      }
       if (dumptrace == 1)
         pcap_dump_close(pdump);
       sig1 = 2;
@@ -175,9 +181,6 @@ int check_signal_flags() {
       usleep(30000); /* wait here 30 msec, for parent to read this data */
       print_bins(&rev, mon_pipe2);
       usleep(30000); /* wait here 30 msec, for parent to read this data */
-      if (pd != NULL) {
-        pcap_breakloop(pd);
-      }
       if (dumptrace == 1)
         pcap_dump_close(pdump);
       sig2 = 2;
@@ -559,10 +562,6 @@ void print_speed(u_char *user, const struct pcap_pkthdr *h, const u_char *p) {
     return;
   }
 
-  if (check_signal_flags()) {
-    return;
-  }
-
   current.sec = h->ts.tv_sec;
   current.usec = h->ts.tv_usec;
   current.time = (current.sec * 1000000) + current.usec;
@@ -787,7 +786,7 @@ void print_speed(u_char *user, const struct pcap_pkthdr *h, const u_char *p) {
 
       void init_pkttrace(I2Addr srcAddr, struct sockaddr *sock_addr,
                          socklen_t saddrlen, int monitor_pipe[2], char *device,
-                         PortPair* pair, char *direction, int compress) {
+                         PortPair* pair, const char *direction, int compress) {
         char cmdbuf[256], dir[256];
         pcap_handler printer;
         u_char * pcap_userdata = (u_char*) pair;
@@ -1046,6 +1045,10 @@ void print_speed(u_char *user, const struct pcap_pkthdr *h, const u_char *p) {
           log_println(5, "pcap_loop exited %s", pcap_geterr(pd));
         }
 
+        if (check_signal_flags() == 0) {
+          log_println(5, "We should have a sig flag set");
+        }
+
         pcap_close(pd);
 
         log_println(
